package de.titusgames.jglest.model;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;

import com.jme.scene.Node;
import com.jme.util.export.binary.BinaryImporter;
import com.jmex.model.converters.FormatConverter;

import de.titusgames.jglest.playground.GxmlToJme;

public class G3dModelLoader
{
   FormatConverter converter = new GxmlToJme();

   public Node loadModel(URL baseURL, String path) throws IOException,
         URISyntaxException
   {
      ByteArrayOutputStream BO = new ByteArrayOutputStream();

      converter.setProperty("texturedir", baseURL);
      URI uri = baseURL.toURI();
      if (path.lastIndexOf('/') != -1)
      {
         System.out.println("path=" + path);
         System.out.println("path.substring(0, path.lastIndexOf('/'))="
               + path.substring(0, path.lastIndexOf('/')));
         URL textureURL = new URI(uri.getScheme(), uri.getHost(), uri.getPath()
               + path.substring(0, path.lastIndexOf('/')+1),
               uri.getFragment()).toURL();
         converter.setProperty("texturedir", textureURL);
      }
      URL modelURL = new URI(uri.getScheme(), uri.getHost(), uri.getPath()
            + "/" + path, uri.getFragment()).toURL();
      System.out.println("converter.getProperty(\"texturedir\")="
            + converter.getProperty("texturedir"));
      converter.convert(modelURL.openStream(), BO);
      Node node = (Node) BinaryImporter.getInstance().load(
            new ByteArrayInputStream(BO.toByteArray()));
      return node;
   }
}
