package de.titusgames.jglest.model;

import java.util.ArrayList;
import java.util.List;

import com.jme.math.Vector2f;
import com.jme.math.Vector3f;

public class GMesh
{

   // mesh data
   private String               name;
   // calculated later:
   // Texture2D *textures[meshTextureCount];

   private List<String>         texturePaths = new ArrayList<String>();

   // vertex data counts
   private int                  frameCount;
   private int                  vertexCount;
   private int                  indexCount;

   // vertex data
   private List<Vector3f[]> vertices     = new ArrayList<Vector3f[]>();
   private List<Vector3f[]> normals      = new ArrayList<Vector3f[]>();
   private Vector2f[]       texCoords    = null;

   // calculated later:
   // List <List<Vector3f>> tangents=new ArrayList <List<Vector3f>>();
   private int[]        indices      = null;

   // material data
   private Vector3f             diffuseColor;
   private Vector3f             specularColor;
   private float                specularPower;
   private float                opacity;

   // properties
   private boolean              twoSided;
   private boolean              customColor;
   private boolean              diffuseTexture;

   public boolean isCustomColor()
   {
      return customColor;
   }

   public void setCustomColor(boolean customColor)
   {
      this.customColor = customColor;
   }

   public Vector3f getDiffuseColor()
   {
      return diffuseColor;
   }

   public void setDiffuseColor(Vector3f diffuseColor)
   {
      this.diffuseColor = diffuseColor;
   }

   public int getFrameCount()
   {
      return frameCount;
   }

   public void setFrameCount(int frameCount)
   {
      this.frameCount = frameCount;
   }

   public int getIndexCount()
   {
      return indexCount;
   }

   public void setIndexCount(int indexCount)
   {
      this.indexCount = indexCount;
   }

   public float getOpacity()
   {
      return opacity;
   }

   public void setOpacity(float opacity)
   {
      this.opacity = opacity;
   }

   public Vector3f getSpecularColor()
   {
      return specularColor;
   }

   public void setSpecularColor(Vector3f specularColor)
   {
      this.specularColor = specularColor;
   }

   public float getSpecularPower()
   {
      return specularPower;
   }

   public void setSpecularPower(float specularPower)
   {
      this.specularPower = specularPower;
   }

   public boolean isTwoSided()
   {
      return twoSided;
   }

   public void setTwoSided(boolean twoSided)
   {
      this.twoSided = twoSided;
   }

   public int getVertexCount()
   {
      return vertexCount;
   }

   public void setVertexCount(int vertexCount)
   {
      this.vertexCount = vertexCount;
   }

   public boolean addNormals(Vector3f[] e)
   {
      return normals.add(e);
   }

   public void setTexCoords(Vector2f[] e)
   {
      texCoords=e;
   }

   public boolean addTexturePath(String e)
   {
      return texturePaths.add(e);
   }

   public boolean addVertices(Vector3f[] e)
   {
      return vertices.add(e);
   }

   public int[] getIndices()
   {
      return indices;
   }

   public List<Vector3f[]> getNormals()
   {
      return normals;
   }

   public Vector2f[] getTexCoords()
   {
      return texCoords;
   }

   public List<String> getTexturePaths()
   {
      return texturePaths;
   }

   public List<Vector3f[]> getVertices()
   {
      return vertices;
   }

   public String getName()
   {
      return name;
   }

   public void setName(String name)
   {
      this.name = name;
   }

   public void setIndices(int[] indices)
   {
      this.indices = indices;
   }

   public boolean isDiffuseTexture()
   {
      return diffuseTexture;
   }

   public void setDiffuseTexture(boolean diffuseTexture)
   {
      this.diffuseTexture = diffuseTexture;
   }

   // calculated later:
   // InterpolationData interpolationData;

}
