package de.titusgames.jglest.model;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class GTerrain
{
   int           version;
   int           maxPlayers;
   int           width;
   int           height;
   int           altFactor;
   int           waterLevel;

   List<GPlayer> players = new ArrayList<GPlayer>();
   
   float[] terrainHeight;
   int[] surfaces;
   int[] objects;

   public GTerrain()
   {
      super();
      // TODO Auto-generated constructor stub
   }

   public int getAltFactor()
   {
      return altFactor;
   }

   public void setAltFactor(int altFactor)
   {
      this.altFactor = altFactor;
   }

   public int getHeight()
   {
      return height;
   }

   public void setHeight(int height)
   {
      this.height = height;
   }

   public int getMaxPlayers()
   {
      return maxPlayers;
   }

   public void setMaxPlayers(int maxPlayers)
   {
      this.maxPlayers = maxPlayers;
   }

   public int getVersion()
   {
      return version;
   }

   public void setVersion(int version)
   {
      this.version = version;
   }

   public int getWaterLevel()
   {
      return waterLevel;
   }

   public void setWaterLevel(int waterLevel)
   {
      this.waterLevel = waterLevel;
   }

   public int getWidth()
   {
      return width;
   }

   public void setWidth(int width)
   {
      this.width = width;
   }

   public List<GPlayer> getPlayers()
   {
      return players;
   }

   public void addPlayer(GPlayer player)
   {
      this.players.add(player);
   }

   public float[] getTerrainHeight()
   {
      return terrainHeight;
   }

   public void setTerrainHeight(float[] terrainHeight)
   {
      this.terrainHeight = terrainHeight;
   }

   public int[] getObjects()
   {
      return objects;
   }

   public void setObjects(int[] objects)
   {
      this.objects = objects;
   }

   public int[] getSurfaces()
   {
      return surfaces;
   }

   public void setSurfaces(int[] surfaces)
   {
      this.surfaces = surfaces;
   }
   
   public float[] smoothHeight(float[] terrainHeight,int w, int h)
   {
      
      float[] newTerrainHeight=Arrays.copyOf(getTerrainHeight(),terrainHeight.length);
      for(int y=0;y<h;y++)
      {
         for(int x=0;x<w;x++)
         {
            float newheight=0.0f;
            for(int l=-1;l<2;l++)
            {
               for(int k=-1;k<2;k++)
               {
                  int pos=(y+l)*w+(x+k);
                  if((pos>0)&& pos<terrainHeight.length)
                  {
                     newheight+=terrainHeight[pos];
                  }
                  else
                  {
                     newheight+=terrainHeight[y*w+x];
                  }
               }
            }
            newheight=newheight/9;
            newTerrainHeight[y*w+x]=newheight;
         }
      }
      return newTerrainHeight;
   }
   
}
