package de.titusgames.jglest.terrain;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

public class AlphaCalculator
{

   public AlphaCalculator()
   {
      super();
   }

   public BufferedImage[] createAlphaTexture(
         int[] surface, int height, int width, int numberOfGroundTypes)
   {
      BufferedImage[] alphas = new BufferedImage[numberOfGroundTypes];
      Graphics2D[] alphaGraphics2D = new Graphics2D[numberOfGroundTypes];

      for (int i = 0; i < alphas.length; i++)
      {
         alphas[i] = new BufferedImage(width, height,
               BufferedImage.TYPE_4BYTE_ABGR);
         alphaGraphics2D[i] = alphas[i].createGraphics();
         alphaGraphics2D[i].setColor(Color.WHITE);
      }
      for (int i = 0; i < surface.length; i++)
      {
         int x = i % width;
         int y = (i - x) / width;
         int currentsurface = surface[i] - 1;
         System.out.println("x=" + x + " y=" + y + " currentsurface="
               + currentsurface);
         if (currentsurface < numberOfGroundTypes)
         {
            alphaGraphics2D[currentsurface].drawLine(x, y, x, y);
         }
         else
         {
            System.out.println("surface ignored:" + currentsurface);
         }
      }
      return alphas;
   }
}
