package de.titusgames.jglest.terrain;

import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.io.File;
import java.io.IOException;
import java.util.Collection;

import javax.imageio.ImageIO;

import de.titusgames.jglest.tileset.PathChance;
import de.titusgames.jglest.tools.RandomTool;

public class TextureMerger
{
   int factor;

   public TextureMerger(int factor)
   {
      this.factor = factor;
   }

   public TextureMerger()
   {
      this(8);
   }

   public BufferedImage createTexture(String basePath,Collection<PathChance> pathChanceCol) throws IOException
   {
      float[] chances = new float[pathChanceCol.size()];
      BufferedImage[] icons = new BufferedImage[pathChanceCol.size()];
      int i = 0;
      for (PathChance pathChance : pathChanceCol)
      {
         chances[i] = pathChance.getChance();
         System.out.println("pathChance.getPath()="+basePath+File.separator+pathChance.getPath());
         icons[i] = ImageIO.read(new File(basePath+File.separator+pathChance.getPath()));
         System.out.println("width="+icons[i].getWidth());
         i++;
      }
      int inputTextureWidth = icons[0].getWidth();
      int calculatedWidth = inputTextureWidth * factor;
      BufferedImage image = new BufferedImage(calculatedWidth, calculatedWidth,
            BufferedImage.TYPE_3BYTE_BGR);
      Graphics2D graphics2D = image.createGraphics();
      RandomTool randomTool = new RandomTool();
      for (int x = 0; x < factor; x++)
      {
         for (int y = 0; y < factor; y++)
         {
            int index = randomTool.getNextInt(chances);
            graphics2D.drawImage(
                  icons[index], x * inputTextureWidth, y
                        * inputTextureWidth, new ImageObserver()
                  {

                     public boolean imageUpdate(
                           Image img, int infoflags, int x, int y, int width,
                           int height)
                     {
                        return false;
                     }

                  });
         }
      }
      return image;
   }
}
