/*
 * Created by Titus Tscharntke on 08.12.2009
*/
package de.titusgames.jglest.tileset;

import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class Tileset
{
   private List<TilesetSurface>          surfaces      = new ArrayList<TilesetSurface>();
   private List<TilesetObject>           objects       = new ArrayList<TilesetObject>();
   private HashMap<String, TilesetSound> ambientSounds = new HashMap<String, TilesetSound>();
   private TilesetParameters             parameters=new TilesetParameters();
   URL baseUrl;

   /**
    * 
    */
   public Tileset(URL baseUrl)
   {
      super();
      this.baseUrl=baseUrl;
   }

   public List<TilesetSurface> getSurfaces()
   {
      return surfaces;
   }

   public void addSurfaces(TilesetSurface surface)
   {
      this.surfaces.add(surface);
   }

   public List<TilesetObject> getObjects()
   {
      return objects;
   }

   public void addObject(TilesetObject object)
   {
      this.objects.add(object);
   }
   public TilesetSound getSound(String soundName)
   {
      return ambientSounds.get(soundName);
   }

   public TilesetSound putSound(String soundName, TilesetSound tilesetSound)
   {
      return ambientSounds.put(soundName, tilesetSound);
   }

   public TilesetParameters getParameters()
   {
      return parameters;
   }

   public URL getBaseUrl()
   {
      return baseUrl;
   }

   public void setBaseUrl(URL baseUrl)
   {
      this.baseUrl = baseUrl;
   }

}
