package de.titusgames.jglest.tileset;

import java.util.ArrayList;

import com.jme.scene.Node;

public class TilesetModels
{
   ArrayList<ArrayList<Node>> modelGroups = new ArrayList<ArrayList<Node>>();
   int                        counter     = 0;

   public TilesetModels()
   {
      super();
   }

   public ArrayList<ArrayList<Node>> getModelGroups()
   {
      return modelGroups;
   }

   public void addNodeList(ArrayList<Node> nodeGroup)
   {
      modelGroups.add(nodeGroup);
   }

   /**
    * returns a node for the given i. i represents glests (very strange) model
    * numbering system.
    * 
    * @param i
    * @return
    */
   public Node getNodeForNumber(int i)
   {
      counter++;
      if (i < modelGroups.size())
      {
         ArrayList<Node> list = modelGroups.get(i);
         return list.get(counter % list.size());
      }
      return null;
   }
}
