package de.titusgames.jglest.xml.parser;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import de.titusgames.jglest.model.G3dModel;

public class G3dXmlReader
{

   private SAXParserFactory factory;
   private SAXParser        parser;

   /**
    * parsed das xml-File mit DTD-Ueberpruefung
    * 
    * @param xmlFile
    * @throws HTException
    */
   public void checkDTD(File xmlFile) throws Exception
   {
      factory = SAXParserFactory.newInstance();
      // Erzeugung des Parsers über diese Factory
      factory.setValidating(true/* false */); /* !!! */
      G3dXmlSaxHandler g3dSaxHandler = new G3dXmlSaxHandler();
      try
      {
         parser = factory.newSAXParser();
         parser.parse(xmlFile, g3dSaxHandler);
         if (g3dSaxHandler.getError().length() > 0)
         {
            throw new Exception("illegal g3dxml-File '"
                  + xmlFile.getAbsolutePath() + "'\n"
                  + g3dSaxHandler.getError());
         }
      }
      catch (Exception e)
      {
         throw e;
      }
   }

   public G3dModel readModel(File xmlFile) throws Exception
   {
      FileInputStream fis = new FileInputStream(xmlFile);
      BufferedInputStream bis = new BufferedInputStream(fis);
      return readModel(bis);
   }

   public G3dModel readModel(InputStream stream) throws Exception
   {
      factory = SAXParserFactory.newInstance();
      // Erzeugung des Parsers über diese Factory
      factory.setValidating(true/* false */); /* !!! */
      G3dXmlSaxHandler g3dSaxHandler = new G3dXmlSaxHandler();
      try
      {
         parser = factory.newSAXParser();
         parser.parse(stream, g3dSaxHandler);
         if (g3dSaxHandler.getError().length() > 0)
         {
            throw new Exception("illegal g3d.xml-stream '" + stream.toString()
                  + "'\n" + g3dSaxHandler.getError());
         }
         return g3dSaxHandler.getModel();
      }
      catch (Exception e)
      {
         throw e;
      }
   }

   public static void main(String[] args)
   {
      G3dXmlReader xmlReader = new G3dXmlReader();
      try
      {
         xmlReader.readModel(new File("resources/acolyte_standing.xml"));
         // messungDTO = messdatenXmlReader.createDTO(new
         // File("D:\\Metadaten.xml"));
         // System.out.println("Die Messung:" + messungDTO);
         System.out.println("file parsed");
      }
      catch (Exception e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }

   }
}
