package de.titusgames.jglest.xml.parser;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import de.titusgames.jglest.model.GTerrain;

public class GbmXmlReader
{

   private SAXParserFactory factory;
   private SAXParser        parser;

   // /**
   // * parsed das xml-File mit DTD-Ueberpruefung
   // *
   // * @param xmlFile
   // * @throws HTException
   // */
   // public void checkDTD(File xmlFile) throws Exception
   // {
   // factory = SAXParserFactory.newInstance();
   // // Erzeugung des Parsers über diese Factory
   // factory.setValidating(true/* false */); /* !!! */
   // G3dXmlSaxHandler g3dSaxHandler = new G3dXmlSaxHandler();
   // try
   // {
   // parser = factory.newSAXParser();
   // parser.parse(xmlFile, g3dSaxHandler);
   // if (g3dSaxHandler.getError().length() > 0)
   // {
   // throw new Exception("illegal g3dxml-File '"
   // + xmlFile.getAbsolutePath() + "'\n"
   // + g3dSaxHandler.getError());
   // }
   // }
   // catch (Exception e)
   // {
   // throw e;
   // }
   // }

   public GTerrain readGbmXml(File xmlFile) throws Exception
   {
      FileInputStream fis = new FileInputStream(xmlFile);
      BufferedInputStream bis = new BufferedInputStream(fis);
      return readGbmXml(bis);
   }

   public GTerrain readGbmXml(InputStream inputStream) throws Exception
   {
      factory = SAXParserFactory.newInstance();
      // Erzeugung des Parsers über diese Factory
      // factory.setValidating(true/* false */); /* !!! */
      GbmXmlSaxHandler gbmXmlSaxHandler = new GbmXmlSaxHandler();
      try
      {
         parser = factory.newSAXParser();
         parser.parse(inputStream, gbmXmlSaxHandler);
         if (gbmXmlSaxHandler.getError().length() > 0)
         {
            throw new Exception("illegal gbm.xml-stream '"
                  + inputStream.toString() + "'\n"
                  + gbmXmlSaxHandler.getError());
         }
         return gbmXmlSaxHandler.getTerrain();
      }
      catch (Exception e)
      {
         throw e;
      }
   }

   public static void main(String[] args)
   {
      GbmXmlReader xmlReader = new GbmXmlReader();
      try
      {
         xmlReader.readGbmXml(new File("resources/conflict.xml"));
         // messungDTO = messdatenXmlReader.createDTO(new
         // File("D:\\Metadaten.xml"));
         // System.out.println("Die Messung:" + messungDTO);
         System.out.println("file parsed");
      }
      catch (Exception e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }

   }
}
