package de.titusgames.jglest.xml.parser;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.net.URL;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import de.titusgames.jglest.tileset.Tileset;

public class TilesetXmlReader
{

   private SAXParserFactory factory;
   private SAXParser        parser;

   // /**
   // * parsed das xml-File mit DTD-Ueberpruefung
   // *
   // * @param xmlFile
   // * @throws HTException
   // */
   // public void checkDTD(File xmlFile) throws Exception
   // {
   // factory = SAXParserFactory.newInstance();
   // // Erzeugung des Parsers über diese Factory
   // factory.setValidating(true/* false */); /* !!! */
   // G3dXmlSaxHandler g3dSaxHandler = new G3dXmlSaxHandler();
   // try
   // {
   // parser = factory.newSAXParser();
   // parser.parse(xmlFile, g3dSaxHandler);
   // if (g3dSaxHandler.getError().length() > 0)
   // {
   // throw new Exception("illegal g3dxml-File '"
   // + xmlFile.getAbsolutePath() + "'\n"
   // + g3dSaxHandler.getError());
   // }
   // }
   // catch (Exception e)
   // {
   // throw e;
   // }
   // }

   public Tileset readXml(File xmlFile) throws Exception
   {
      FileInputStream fis = new FileInputStream(xmlFile);
      BufferedInputStream bis = new BufferedInputStream(fis);
      return readXml(bis, xmlFile.getParentFile().toURI().toURL());
   }

   public Tileset readXml(InputStream inputStream, URL baseUrl)
         throws Exception
   {
      factory = SAXParserFactory.newInstance();
      // Erzeugung des Parsers über diese Factory
      // factory.setValidating(true/* false */); /* !!! */
      TilesetXmlSaxHandler xmlSaxHandler = new TilesetXmlSaxHandler(baseUrl);
      try
      {
         parser = factory.newSAXParser();
         parser.parse(inputStream, xmlSaxHandler);
         if (xmlSaxHandler.getError().length() > 0)
         {
            throw new Exception("illegal tileset.xml-stream '"
                  + inputStream.toString() + "'\n" + xmlSaxHandler.getError());
         }
         return xmlSaxHandler.getTileset();
      }
      catch (Exception e)
      {
         throw e;
      }
   }

   public static void main(String[] args)
   {
      TilesetXmlReader xmlReader = new TilesetXmlReader();

      try
      {
         xmlReader.readXml(new File("resources/evergreen/evergreen.xml"));
         // messungDTO = messdatenXmlReader.createDTO(new
         // File("D:\\Metadaten.xml"));
         // System.out.println("Die Messung:" + messungDTO);
         System.out.println("file parsed");
      }
      catch (Exception e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }

   }
}
