package de.titusgames.jglest.xml.parser;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.helpers.DefaultHandler;

import com.jme.math.Vector3f;

public class XmlSaxHandlerBase extends DefaultHandler
{
   private StringBuffer parseErrorTxt = new StringBuffer("");

   protected Boolean getBooleanValue(Attributes attributes, String attributename)
   {
      String s = attributes.getValue(attributename);
      if (s == null)
         return null;
      return Boolean.parseBoolean(s);
   }

   protected Integer getIntegerValue(Attributes attributes, String attributename)
   {
      String s = attributes.getValue(attributename);
      if (s == null)
         return null;
      return Integer.parseInt(s);
   }

   protected Float getFloatValue(Attributes attributes, String attributename)
   {
      String s = attributes.getValue(attributename);
      if (s == null)
         return null;
      return Float.parseFloat(s);
   }

   protected Vector3f getVector3dValue(
         Attributes attributes, String attrX, String attrY, String attrZ)
   {
      Float current;
      Vector3f vector3f = new Vector3f();
      current = getFloatValue(attributes, attrX);
      if (current != null)
      {
         vector3f.setX(current);
      }
      current = getFloatValue(attributes, attrY);
      if (current != null)
      {
         vector3f.setY(current);
      }
      current = getFloatValue(attributes, attrZ);
      if (current != null)
      {
         vector3f.setZ(current);
      }
      return vector3f;

   }

   public void error(SAXParseException e) throws SAXException
   {
      parseErrorTxt.append("Fehler: " + e.getLocalizedMessage() + "\n");
   }

   public String getError()
   {
      return parseErrorTxt.toString();
   }

   // public void characters(char[] ch, int start, int length)
   // throws SAXException
   // {
   // String readChars = new String(ch, start, length);
   // XmlNode xmlNode = (XmlNode) currentNodes.peek();
   // String currentValue = xmlNode.getNodeValue();
   // if (currentValue == null)
   // {
   // currentValue = "";
   // }
   // xmlNode.setNodeValue(currentValue + readChars);
   // super.characters(ch, start, length);
   // }

}
